// Aleksander Alekseev, 2024
// https://eax.me/fbg6-klipper/

X = 110;
Y = 80;
Z = 40;

t = 4;

m3_dia = 3.5;

opi_dx = 80;
opi_dy = 50;

buzzer_delta = 40;
buzzer_hole_dia = 12;
buzzer_offset = -15;

ant_delta = 10;

module opi_holes() {
    translate([opi_dx/2, opi_dy/2, 0])
        cylinder(h = t*2, d = m3_dia, center = true, $fn = 25);
    translate([opi_dx/2, -opi_dy/2, 0])
        cylinder(h = t*2, d = m3_dia, center = true, $fn = 25);
    translate([-opi_dx/2, opi_dy/2, 0])
        cylinder(h = t*2, d = m3_dia, center = true, $fn = 25);
    translate([-opi_dx/2, -opi_dy/2, 0])
        cylinder(h = t*2, d = m3_dia, center = true, $fn = 25);
}

module buzzer_holes() {
    translate([-buzzer_delta/2, 0, 0])
        cylinder(h = t*2, d = m3_dia, center = true, $fn = 25);
        
    translate([buzzer_delta/2, 0, 0])
        cylinder(h = t*2, d = m3_dia, center = true, $fn = 25);
        
    cylinder(h = t*2, d = buzzer_hole_dia, center = true, $fn = 25);
}

module ant_holes() {
    translate([-ant_delta/2, 0, 0])
        cylinder(h = t*2, d = m3_dia, center = true, $fn = 25);
    translate([ant_delta/2, 0, 0])
        cylinder(h = t*2, d = m3_dia, center = true, $fn = 25);
}

module usb_holes() {
    rotate([0, 0, 90]) ant_holes();
}

difference() {
    union() {
        cube([X, Y, t], center = true);

        translate([0, -Y/2+t/2, Z/2-t/2])
            cube([X, t, Z], center=true);
    }

    translate([10, 10, 0])
        opi_holes();

    translate([buzzer_offset, -Y/2+t/2, Z/2])
        rotate([90, 0, 0])
            buzzer_holes();
            
    translate([-X/2 + ant_delta, 10, 0])     
        ant_holes();
        
    translate([0, -Y/2 + 15, 0]) usb_holes();
    translate([35, -Y/2 + 15, 0]) usb_holes();
}
